# Class FocusAdapter

java.lang.Object
java.awt.event.FocusAdapter

All Implemented Interfaces:
  `FocusListener, EventListener`

Direct Known Subclasses:
  `BasicSplitPaneUI.FocusHandler, BasicTabbedPaneUI.FocusHandler`

public abstract class FocusAdapter extends Object implements FocusListener
An abstract adapter class for receiving keyboard focus events. The methods in this class are empty. This class exists as convenience for creating listener objects.

Extend this class to create a `FocusEvent` listener and override the methods for the events of interest. (If you implement the `FocusListener` interface, you have to define all of the methods in it. This abstract class defines null methods for them all, so you can only have to define methods for events you care about.)

Create a listener object using the extended class and then register it with a component using the component's `addFocusListener` method. When the component gains or loses the keyboard focus, the relevant method in the listener object is invoked, and the `FocusEvent` is passed to it.

Since:
  1.1
See Also:
  - `FocusEvent`
  - `FocusListener`
  - Tutorial: Writing a Focus Listener

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `FocusAdapter()`
  Constructs a `FocusAdapter`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `focusGained(FocusEvent e)`
  Invoked when a component gains the keyboard focus.
  `void`
  `focusLost(FocusEvent e)`
  Invoked when a component loses the keyboard focus.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### FocusAdapter

    protected FocusAdapter()
    Constructs a `FocusAdapter`.

- ## Method Details

  - ### focusGained

    public void focusGained(FocusEvent e)
    Invoked when a component gains the keyboard focus.
    Specified by:
      `focusGained` in interface `FocusListener`
    Parameters:
      `e` - the event to be processed

  - ### focusLost

    public void focusLost(FocusEvent e)
    Invoked when a component loses the keyboard focus.
    Specified by:
      `focusLost` in interface `FocusListener`
    Parameters:
      `e` - the event to be processed